// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "UIComponent.hpp"

using namespace Dawn;

std::vector<std::shared_ptr<UIComponent>> UIComponent::getChildren() {
  return {};
}

std::vector<struct UIShaderQuad> UIComponent::getQuads(const glm::vec2 parent) {
  glm::vec2 transform = parent + position;
  std::vector<struct UIShaderQuad> quads = this->getSelfQuads(transform);

  auto children = getChildren();
  for(auto &c : children) {
    auto childQuads = c->getQuads(transform);
    quads.insert(quads.end(), childQuads.begin(), childQuads.end());
  }

  return quads;
}