// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "UILabel.hpp"

using namespace Dawn;

std::vector<struct UIShaderQuad> UILabel::getSelfQuads(const glm::vec2 t) {
  std::vector<struct UIShaderQuad> quads;
  if(this->texture == nullptr) return quads;

  const std::wstring text = L"Hello World!";
  glm::vec2 position = t;
  glm::vec4 quad;

  for(wchar_t c : text) {
    auto info = texture->getCharacterData(c);
    quads.push_back({
      .quad = {
        position.x,
        position.y,
        position.x + info.size.x,
        position.y + info.size.y
      },
      .uv = info.quad,
      .color = COLOR_WHITE
    });
    position += info.advance;
  }

  return quads;
}

void UILabel::setFont(std::shared_ptr<TrueTypeTexture> texture) {
  this->texture = texture;
}